;;;                                           <grafik-zum-zeichnen-von-wegen.scm>
;
; Grafikprogramm z.B. fuer die Darstellung des Weges beim tsp - Problem.

;;; ----- Grafik-Paket laden -----
(require (lib "graphics.ss" "graphics"))
;;; ----- globale Variable definieren -----
; #f kennzeichnet, dass die Grafik nicht gestartet wurde.
(define Grafik #f)
; diese wird gesetzt von der folgenden Funktion:
;;; ----- grafik-starten -----
(define
  (grafik-starten breite hoehe)
  (open-graphics)
  (set!
   Grafik
   (open-viewport "Grafik fuer Wege" breite hoehe)))
(define
  (standard-grafik-starten)
  (grafik-starten 500 500))
;;; ----- und beenden -----
(define
  (grafik-beenden)
  (cond
    ((not Grafik)
     (display "Grafik ist nicht gestartet!")(newline))
    (else
     (close-graphics)
     (set! Grafik #f))))
;;; ===== zeichne =====
; zeichnet den Weg.
; Die Funktion bekommt eine Liste von Punkten uebergeben, die Punkte
; sind zweielementige Listen von Zahlen.
; Als zweiten Parameter bekommt die Funktion einen  boolean - Wert
; uebergeben, der einerseits festlegt, ob die Grafik auf eine Taste
; warten soll oder nicht und andrerseits dann die Grafikdarstellung
; beendet.
(define
  (zeichne weg warten?)
  (if (not Grafik) (standard-grafik-starten))
  ; Initialisieren des Grafik-Fensters, Hintergrund weiss.
  ((draw-viewport Grafik) (make-rgb 1 1 1))
  (zeichne-alle-kanten weg)
  (if
   warten?
   (begin
     (display "Taste zum Abbruch !")
     (viewport-flush-input Grafik)
     (key-value (get-key-press Grafik))))
   (grafik-beenden))

;;; ----- zeichne-alle-kanten -----
(define
  (zeichne-alle-kanten weg)
  (cond
    ((null? weg) (void)) ; kein Punkt --> nichts tun.
    ((null? (rest weg))  ; ein Punkt  --> Punkt zeichnen.
     (zeichne-punkt (first weg)))
    (else                ; zwei Punkte --> Punkt und Kante zeichnen.
     (zeichne-punkt (first weg))
     (zeichne-kante (first weg) (second weg))
     (zeichne-alle-kanten (rest weg)))))
;;; ----- zeichne-punkt -----
(define
  (zeichne-punkt punkt)
  ((draw-solid-ellipse Grafik)
   (make-posn 
    (- (first punkt) 2)
    (- (second punkt) 2))
    3 3 (make-rgb 1 0 0)))
;;; -----  -----
(define
  (zeichne-kante von nach)
  ((draw-line Grafik)
   (make-posn (first von) (second von))
   (make-posn (first nach) (second nach))
   (make-rgb 0 0 0)))

; Tests:
;(grafik-starten 100 100)
;(zeichne
; '((10 40) (10 50) (20 50) (30 50) (40 50) (50 50) (50 60) (50 70) (60 70) (60 80) (70 80) (80 80) (90 80) (90 70) (90 60))
; #t)
(zeichne
 '((148 48)
   (142 124)
   (296 173)
   (321 224)
   (457 135)
   (494 355)
   (284 487)
   (280 477)
   (329 436)
   (279 424)
   (200 380)
   (156 435)
   (93 355)
   (171 280)
   (174 189)
   (264 48)
   (451 50)
   (415 17)
   (280 15)
   (234 28)
   (148 48))
 #t)
